#include <list>
#include <string>
#include <fstream>
#include <iostream>

const int TRANSLEN = 2;  //length of file fields
const int KEYLEN = 20;
const string HIGHVALUE = "zzzzzzzz";
const string INSERT = "I ";
const string DELETE = "D ";
const string CLEARTRANS = "  ";

class KeyedItem {
  public: 
    string trans;
    string key;
    string value;
    KeyedItem(string t, string k, string v) {
      trans = t; key = k, value = v;
    }
};

typedef list<KeyedItem> KEYEDLIST;

KEYEDLIST runTransactions(ifstream& masterlist, ifstream& translist, 
                          int print = 0,
                          int trans = TRANSLEN, int key = KEYLEN);
KEYEDLIST runTransactions(KEYEDLIST master, KEYEDLIST trans,
                          int print = 0);
KEYEDLIST fileToKeyedList(ifstream& file, 
                          int trans = TRANSLEN, int key = KEYLEN);
void printKeyedList(KEYEDLIST list, 
                    ostream& out = cout);

